/*
 * Copyright (c) 2018, Andrew EP | ElPinche256 <https://github.com/ElPinche256>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package io.reisub.openosrs.autodropper;

import net.runelite.client.config.Button;
import net.runelite.client.config.ConfigGroup;
import net.runelite.client.config.ConfigItem;

@ConfigGroup("chaosautodropper")

public interface Config extends net.runelite.client.config.Config {
    @ConfigItem(
            keyName = "itemNames",
            name = "Item names",
            description = "List of item names, separated with a semicolon.",
            position = 0
    )
    default String itemNames() { return "Empty plant pot"; }

    @ConfigItem(
            keyName = "itemIds",
            name = "Item IDs",
            description = "List of item IDs, separated with a semicolon. Useful if you want to differentiate between 2 items with the same name.",
            position = 1
    )
    default String itemIds() { return ""; }

    @ConfigItem(
            keyName = "dropWhileItemSelected",
            name = "Drop while item selected",
            description = "If enabled, this will drop items even if an item is selected, resulting in deselecting the item.",
            position = 2
    )
    default boolean dropWhileItemSelected() { return false; }

    @ConfigItem(
            keyName = "reloadButton",
            name = "Reload configuration",
            description = "Force reload the configuration.",
            position = 100
    )
    default Button reloadButton() { return new Button(); }
}