/*
 * Copyright (c) 2018, Andrew EP | ElPinche256 <https://github.com/ElPinche256>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package io.reisub.openosrs.shopper;

import net.runelite.client.config.Button;
import net.runelite.client.config.ConfigGroup;
import net.runelite.client.config.ConfigItem;
import net.runelite.client.config.ConfigSection;

@ConfigGroup("ChaosShopperConfig")

public interface Config extends net.runelite.client.config.Config {
    @ConfigItem(
            keyName = "npcName",
            name = "NPC Name",
            description = "Name of the NPC to buy from",
            position = 0
    )
    default String npcName() {
        return "";
    }

    @ConfigSection(
            keyName = "itemOne",
            name = "Item 1",
            description = "Configure the item to buy",
            position = 10
    )
    String itemOne = "itemOne";

    @ConfigItem(
            keyName = "itemOneEnabled",
            name = "Enable",
            description = "Enable the buying of this item",
            position = 11
    )
    default boolean itemOneEnabled() {
        return true;
    }

    @ConfigItem(
            keyName = "itemOneName",
            name = "Name",
            description = "Name of the item",
            position = 12
    )
    default String itemOneName() {
        return "";
    }

    @ConfigItem(
            keyName = "itemOneAmount",
            name = "Amount",
            description = "Amount of the item to buy",
            position = 13
    )
    default int itemOneAmount() {
        return 0;
    }

    @ConfigItem(
            keyName = "itemOneMinInStore",
            name = "Min in store",
            description = "Amount to keep in store to prevent overpaying",
            position = 14
    )
    default int itemOneMinInStore() {
        return 0;
    }

    @ConfigSection(
            keyName = "itemTwo",
            name = "Item 2",
            description = "Configure the item to buy",
            closedByDefault = true,
            position = 20
    )
    String itemTwo = "itemTwo";

    @ConfigItem(
            keyName = "itemTwoEnabled",
            name = "Enable",
            description = "Enable the buying of this item",
            position = 21
    )
    default boolean itemTwoEnabled() {
        return false;
    }

    @ConfigItem(
            keyName = "itemTwoName",
            name = "Name",
            description = "Name of the item",
            position = 22
    )
    default String itemTwoName() {
        return "";
    }

    @ConfigItem(
            keyName = "itemTwoAmount",
            name = "Amount",
            description = "Amount of the item to buy",
            position = 23
    )
    default int itemTwoAmount() {
        return 0;
    }

    @ConfigItem(
            keyName = "itemTwoMinInStore",
            name = "Min in store",
            description = "Amount to keep in store to prevent overpaying",
            position = 24
    )
    default int itemTwoMinInStore() {
        return 0;
    }

    @ConfigSection(
            keyName = "itemThree",
            name = "Item 3",
            description = "Configure the item to buy",
            closedByDefault = true,
            position = 30
    )
    String itemThree = "itemThree";

    @ConfigItem(
            keyName = "itemThreeEnabled",
            name = "Enable",
            description = "Enable the buying of this item",
            position = 31
    )
    default boolean itemThreeEnabled() {
        return false;
    }

    @ConfigItem(
            keyName = "itemThreeName",
            name = "Name",
            description = "Name of the item",
            position = 32
    )
    default String itemThreeName() {
        return "";
    }

    @ConfigItem(
            keyName = "itemThreeAmount",
            name = "Amount",
            description = "Amount of the item to buy",
            position = 33
    )
    default int itemThreeAmount() {
        return 0;
    }

    @ConfigItem(
            keyName = "itemThreeMinInStore",
            name = "Min in store",
            description = "Amount to keep in store to prevent overpaying",
            position = 34
    )
    default int itemThreeMinInStore() {
        return 0;
    }

    @ConfigSection(
            keyName = "itemFour",
            name = "Item 4",
            description = "Configure the item to buy",
            closedByDefault = true,
            position = 40
    )
    String itemFour = "itemFour";

    @ConfigItem(
            keyName = "itemFourEnabled",
            name = "Enable",
            description = "Enable the buying of this item",
            position = 41
    )
    default boolean itemFourEnabled() {
        return false;
    }

    @ConfigItem(
            keyName = "itemFourName",
            name = "Name",
            description = "Name of the item",
            position = 42
    )
    default String itemFourName() {
        return "";
    }

    @ConfigItem(
            keyName = "itemFourAmount",
            name = "Amount",
            description = "Amount of the item to buy",
            position = 43
    )
    default int itemFourAmount() {
        return 0;
    }

    @ConfigItem(
            keyName = "itemFourMinInStore",
            name = "Min in store",
            description = "Amount to keep in store to prevent overpaying",
            position = 44
    )
    default int itemFourMinInStore() {
        return 0;
    }

    @ConfigSection(
            keyName = "itemFive",
            name = "Item 5",
            description = "Configure the item to buy",
            closedByDefault = true,
            position = 50
    )
    String itemFive = "itemFive";

    @ConfigItem(
            keyName = "itemFiveEnabled",
            name = "Enable",
            description = "Enable the buying of this item",
            position = 51
    )
    default boolean itemFiveEnabled() {
        return false;
    }

    @ConfigItem(
            keyName = "itemFiveName",
            name = "Name",
            description = "Name of the item",
            position = 52
    )
    default String itemFiveName() {
        return "";
    }

    @ConfigItem(
            keyName = "itemFiveAmount",
            name = "Amount",
            description = "Amount of the item to buy",
            position = 53
    )
    default int itemFiveAmount() {
        return 0;
    }

    @ConfigItem(
            keyName = "itemFiveMinInStore",
            name = "Min in store",
            description = "Amount to keep in store to prevent overpaying",
            position = 54
    )
    default int itemFiveMinInStore() {
        return 0;
    }

    @ConfigItem(
            keyName = "startButton",
            name = "Start/Stop",
            description = "Start the script",
            position = 100
    )
    default Button startButton() {
        return new Button();
    }
}